<template>
  <transition name="scale-fade">
    <div
      class="modal_template"
      v-if="visible">
      <div class="modal_template-container container">
        <div class="modal_template-inner">
          <div class="modal_template-header">
            <div
              class="modal_template-close"
              @click="$emit('close')">
              <i class="i-icon-close"></i>
            </div>
          </div>
          <div class="modal_template-body">
            <slot></slot>
          </div>
        </div>
      </div>
      <div class="modal_template-overlay"></div>
    </div>
  </transition>
</template>

<script>
export default {
  name: "ModalTemplate",
  props: {
    visible: {
      type: Boolean,
      default: false
    },
    width: {
      type: String,
      default: '300px'
    },
    height: {
      type: String,
      default: '350px'
    },
  },
}
</script>
<style lang="scss" scoped>
.modal_template {
  position: fixed;
  top: 0px;
  bottom: 0px;
  left: 0px;
  right: 0px;
  z-index: 9;
  display: flex;
  align-items: center;
  &-container {
    overflow: auto;
    max-height: 100vh;
    margin-top: auto;
    z-index: 1;
  }
  &-header {
    display: flex;
    justify-content: flex-end;
    margin-bottom: 15px;
  }
  &-close {
    cursor: pointer;
    display: flex;
    justify-content: center;
    align-items: center;
    width: 30px;
    height: 30px;
    border-radius: 6px;
    background-color: #222b3e;
    border: 1px solid #3b4356;
    box-shadow: 2px 5px 14px 4px #111926;
    color: #ffffff;
  }
  &-overlay {
    background-color: rgba(32, 43, 63, 0.9);
    position: absolute;
    top: 0px;
    right: 0px;
    bottom: 0px;
    left: 0px;
  }
  &-inner {
    width: 100%;
    padding: 0px 10px;
    z-index: 10;
  }
  &-body {
    background-color: #222b3e;
    border: 1px solid #757D8D;
    border-radius: 10px;
    font-size: .875rem;
    min-height: 50px;
    overflow: hidden;
  }
}
</style>
